from animal import Animal

class Fish(Animal):
    def swim(self):  # ryba pływa
        print(f'{self.name}: is swimming!')

def simulate_race(animals_list):
    if len(animals_list) == 0:
        print('No animals to compete!')
        return

    # czy animals_list składa się ze zwierząt (lub obiektów "zwierzęciopodobnych")?
    for a in animals_list:
        # "miękkie" sprawdzanie poprawności:
        #for attr in ["get_name", "get_speed", "eat"]:
        #    if not hasattr(a, attr):
        #        raise TypeError(f"{a} does not have a required attribute: {attr}!")
        # silniejszy test:
        if not isinstance(a, Animal):
            raise TypeError("A non-animal attempted to race!")
        # prościej:
        # if any(not isinstance(a, Animal) for a in animals_list):
        #     raise ValueError("A non-animal attempted to race!")

    print("Competing: {}".format(', '.join('{} ({} km/h)'.format(a.get_name(), a.get_speed()) for a in animals_list)))

    fastest = max(animals_list, key=lambda animal: animal.get_speed())
    print(f"{fastest.get_name()} won!")
    fastest.eat('tasty prize')


if __name__ == "__main__":
    dog = Animal('Dogmeat', 28.0)
    nemo = Fish('Nemo', 56.0)
    nemo.swim()
    nemo.eat('fishfood')
    print(isinstance(nemo, Fish))
    print(isinstance(nemo, Animal))

    simulate_race([dog, nemo])
